'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stringifyQuery = undefined;
exports.mapDeep = mapDeep;

var _qs = require('qs');

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _mapValues = require('lodash/mapValues');

var _mapValues2 = _interopRequireDefault(_mapValues);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stringifyQuery = exports.stringifyQuery = function stringifyQuery(query) {
  return (0, _qs.stringify)((0, _omit2.default)(query));
};

function mapDeep(iteratable, callback) {
  var name = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if ((0, _isArray2.default)(iteratable)) {
    return iteratable.map(function (toIterate) {
      return mapDeep(toIterate, callback, name);
    });
  }

  if ((0, _isPlainObject2.default)(iteratable)) {
    return (0, _mapValues2.default)(iteratable, function (toIterate) {
      return mapDeep(toIterate, callback);
    });
  }

  return callback(iteratable, name);
}